Index: lib/spatial/mapbuilder/examples/flickr/Legend.xsl
===================================================================
--- lib/spatial/mapbuilder/examples/flickr/Legend.xsl	(nonexistent)
+++ lib/spatial/mapbuilder/examples/flickr/Legend.xsl	(revision 4307)
@@ -0,0 +1,174 @@
+<?xml version="1.0" encoding="UTF-8"?>
+<xsl:stylesheet 
+    xmlns:wmc="http://www.opengis.net/context" 
+    xmlns:xsl="http://www.w3.org/1999/XSL/Transform" 
+    xmlns:gml='http://www.opengis.net/gml' 
+    xmlns:wfs='http://www.opengis.net/wfs'
+    xmlns:xlink='http://www.w3.org/1999/xlink'
+    version="1.0">
+<!--
+Description: Convert a Web Map Context into a HTML Legend
+Author:      Cameron Shorter cameron ATshorter.net
+Licence:     LGPL as per: http://www.gnu.org/copyleft/lesser.html
+
+$Id: Legend.xsl 3907 2008-03-06 10:27:06Z steven $
+$Name$
+-->
+  <xsl:output method="xml" encoding="utf-8" omit-xml-declaration="yes"/>
+  
+  <!-- The common params set for all widgets -->
+  <xsl:param name="lang">en</xsl:param>
+  <xsl:param name="modelId"/>
+  <xsl:param name="widgetId"/>
+
+  <xsl:param name="skinDir"/>
+  
+  <!-- Text params for this widget -->
+  <xsl:param name="title"/>
+  
+<!-- The name of the javascript context object to call -->
+  <xsl:param name="featureName"/>
+  <xsl:param name="hidden"/>
+  <xsl:param name="context">config.objects.<xsl:value-of select="$modelId"/></xsl:param>
+
+<!-- Main html -->
+  
+  <xsl:template match="/wmc:OWSContext">
+    <table border="0" cellpadding="1" cellspacing="0">
+      <tr>
+        <th colspan="3">Community MapBuilder Community</th>
+      </tr>
+     
+      <xsl:apply-templates select="wmc:ResourceList/wmc:RssLayer">
+        <xsl:sort select="position()" order="descending" data-type="number"/>
+      </xsl:apply-templates>
+    </table>
+  </xsl:template>
+  
+  <xsl:template match="/wfs:FeatureCollection">
+    <table border="0" cellpadding="1" cellspacing="0">
+      <tr>
+        <th colspan="3">WFS Features</th>
+      </tr>
+      <tr>
+  <!-- Visiblity -->
+        <td>
+          <xsl:if test="$hidden='false'">
+            <input type="checkbox" checked="true" id="legend_{$featureName}" onclick="{$context}.setHidden('{$featureName}',!document.getElementById('legend_{$featureName}').checked)"/>
+          </xsl:if>
+          <xsl:if test="$hidden='true'">
+            <input type="checkbox" id="legend_{$featureName}" onclick="{$context}.setHidden('{$featureName}',! document.getElementById('legend_{$featureName}').checked)"/>
+          </xsl:if>
+        </td>
+  <!-- No query capability yet -->
+        <td>
+        </td>
+        <td>
+          <xsl:value-of select="$featureName"/>
+        </td>
+      </tr>
+    </table>
+  </xsl:template>
+  
+<!-- Layer -->
+  <xsl:template match="wmc:Layer">
+    <tr>
+  <!-- Visiblity -->
+      <td>
+        <xsl:if test="@hidden='0'">
+          <input type="checkbox" checked="true" id="legend_{wmc:Name}" onclick="{$context}.setHidden('{wmc:Name}',!document.getElementById('legend_{wmc:Name}').checked)"/>
+        </xsl:if>
+        <xsl:if test="@hidden='1'">
+          <input type="checkbox" id="legend_{wmc:Name}" onclick="{$context}.setHidden('{wmc:Name}',! document.getElementById('legend_{wmc:Name}').checked)"/>
+        </xsl:if>
+      </td>
+  <!-- Query Image -->
+      <td>
+        <xsl:if test="@queryable='1'">
+          <img
+            id="query_{wmc:Name}"
+            title="Click to set {wmc:Title} as the query layer"
+            onclick="config.objects.{$widgetId}.selectLayer(config.objects.{$widgetId},'{wmc:Name}')"
+            src="{$skinDir}/images/id.gif" />
+        </xsl:if>
+      </td>
+  <!-- Title -->
+      <td>
+        <xsl:choose>
+          <xsl:when test="wmc:Title/@xml:lang">              
+            <xsl:value-of select="wmc:Title[@xml:lang=$lang]"/>
+          </xsl:when>
+          <xsl:otherwise>
+            <xsl:value-of select="wmc:Title"/>
+          </xsl:otherwise>
+        </xsl:choose>
+      </td>
+    </tr>
+  <!-- StyleList -->
+    <tr>
+      <td></td>
+      <td></td>
+      <td>
+      <xsl:if test="wmc:StyleList/wmc:Style[@current='1']/wmc:LegendURL"> 
+          <xsl:element name="IMG">
+              <xsl:attribute name="SRC">
+                <xsl:value-of select="wmc:StyleList/wmc:Style[@current='1']/wmc:LegendURL/wmc:OnlineResource/@xlink:href"/> 
+              </xsl:attribute>
+          </xsl:element>
+         </xsl:if>
+      </td>
+    </tr>
+  </xsl:template>
+  
+   <xsl:template match="wmc:RssLayer">
+    <tr>
+  <!-- Visiblity -->
+      <td>
+        <xsl:if test="@hidden='0'">
+          <input type="checkbox" checked="true" id="legend_{wmc:Title}" onclick="{$context}.setHidden('{wmc:Title}',!document.getElementById('legend_{wmc:Title}').checked)"/>
+        </xsl:if>
+        <xsl:if test="@hidden='1'">
+          <input type="checkbox" id="legend_{wmc:Title}" onclick="{$context}.setHidden('{wmc:Title}',! document.getElementById('legend_{wmc:Title}').checked)"/>
+        </xsl:if>
+      </td>
+  <!-- Query Image -->
+      <td>
+        <xsl:if test="@queryable='1'">
+          <img
+            id="query_{wmc:Name}"
+            title="Click to set {wmc:Title} as the query layer"
+            onclick="config.objects.{$widgetId}.selectLayer(config.objects.{$widgetId},'{wmc:Name}')"
+            src="{$skinDir}/images/id.gif" />
+        </xsl:if>
+      </td>
+  <!-- Title -->
+      <td>
+        <xsl:choose>
+          <xsl:when test="wmc:Title/@xml:lang">              
+            <xsl:value-of select="wmc:Title[@xml:lang=$lang]"/>
+          </xsl:when>
+          <xsl:otherwise>
+            <xsl:value-of select="wmc:Title"/>
+          </xsl:otherwise>
+        </xsl:choose>
+      </td>
+    </tr>
+  <!-- StyleList -->
+    <tr>
+      <td></td>
+      <td></td>
+      <td>
+      <xsl:if test="wmc:StyleList/wmc:Style[@current='1']/wmc:LegendURL"> 
+          <xsl:element name="IMG">
+              <xsl:attribute name="SRC">
+                <xsl:value-of select="wmc:StyleList/wmc:Style[@current='1']/wmc:LegendURL/wmc:OnlineResource/@xlink:href"/> 
+              </xsl:attribute>
+          </xsl:element>
+         </xsl:if>
+      </td>
+    </tr>
+  </xsl:template>
+  
+  <xsl:template match="text()|@*"/>
+  
+</xsl:stylesheet>
Index: lib/spatial/mapbuilder/examples/flickr/FlickrRest2Wfs.js
===================================================================
--- lib/spatial/mapbuilder/examples/flickr/FlickrRest2Wfs.js	(nonexistent)
+++ lib/spatial/mapbuilder/examples/flickr/FlickrRest2Wfs.js	(revision 4307)
@@ -0,0 +1,83 @@
+/*
+ * $Id: FlickrRest2Wfs.js 3883 2008-02-27 15:42:01Z gjvoosten $
+ */
+ 
+// Ensure this object's dependancies are loaded.
+mapbuilder.loadScript(baseDir+"/tool/ToolBase.js");
+
+/**
+ * ad-hoc tool to load flickr rest feed with a single xsl transformation.
+ * this tool populates its model on init.
+ * @constructor
+ * @param toolNode config node for this tool
+ * @param model model that contains this tool
+ */
+function FlickrRest2Wfs(toolNode, model) {
+  ToolBase.apply(this, new Array(toolNode, model));
+  
+  this.url = this.getProperty('mb:url');
+  this.stylesheet = this.getProperty('mb:stylesheet');
+  
+  model.addListener('init', this.safeTransform, this);
+}
+
+/**
+ * XSL transformation, works also on IE with external documents and proxy.
+ * @param objRef reference to this tool
+ */
+FlickrRest2Wfs.prototype.safeTransform = function(objRef) {
+  var url = config.proxyUrl+"?url="+escape(objRef.url);
+  if (MB_IS_MOZ) {
+    var xmlHttp = new XMLHttpRequest();
+    xmlHttp.open("GET", url, false);
+    xmlHttp.send('');
+    var doc = xmlHttp.responseXML;
+    var stylesheet = new XslProcessor(objRef.stylesheet, objRef.model.namespace);
+    stylesheet.setParameter('proxyUrl', config.proxyUrl);
+    objRef.model.doc = stylesheet.transformNodeToObject(doc);
+  } else {
+    var progids = {domdoc: ['Msxml2.DOMDocument.3.0', 'Msxml2.DOMDocument.6.0'],
+          freethreaded: ['Msxml2.FreeThreadedDOMDocument.3.0', 'Msxml2.FreeThreadedDOMDocument.6.0'],
+          xsltpl: ['MSXML2.XSLTemplate.3.0', 'MSXML2.XSLTemplate.6.0'],
+          xmlhttp: ['Msxml2.XMLHTTP.3.0', 'Msxml2.XMLHTTP.6.0']};
+    var xml;
+    for (var i in progids.domdoc) {
+      try {
+        xml = new ActiveXObject(progids.domdoc[i]);
+        break;
+      } catch (e) {}
+    }
+    var xsl = new ActiveXObject(progids.freethreaded[i]);
+    var docCache = new ActiveXObject(progids.xsltpl[i]);
+  
+    var xmlHttp = new ActiveXObject(progids.xmlhttp[i]);
+    xmlHttp.open('GET', objRef.stylesheet, false);
+    xmlHttp.send(null);
+    var xslText = xmlHttp.responseText;
+    
+    // replace url-encoded "%"s in urls to %25, so they get
+    // double-escaped. Ugly hack, but IE needs that.
+    var regex = new RegExp("/\?url=(.[^']*)'/g");
+    var toReplace = xslText.match(/\?url=(.[^']*)'/g);
+    for (var i=0; i<toReplace.length; i++) {
+    	xslText = xslText.replace(toReplace[i], toReplace[i].replace(/%/g,'%25'));
+    }
+    
+    xml.validateOnParse = false;
+    xsl.validateOnParse = false;
+    xsl.resolveExternals = true;
+    xsl.setProperty("AllowDocumentFunction",true); 
+    xsl.async = false;
+    xml.async = false;
+    xsl.loadXML(xslText);
+    xml.load(url);
+    docCache.stylesheet = xsl;
+    var docProcessor = docCache.createProcessor();
+    docProcessor.input = xml;
+    docProcessor.addParameter('proxyUrl', config.proxyUrl, '');
+    docProcessor.transform();
+    objRef.model.doc = (new DOMParser()).parseFromString(docProcessor.output, "text/xml"); 
+  }
+  objRef.model.callListeners('refresh');
+}
+
Index: lib/spatial/mapbuilder/examples/flickr/popup.xsl
===================================================================
--- lib/spatial/mapbuilder/examples/flickr/popup.xsl	(nonexistent)
+++ lib/spatial/mapbuilder/examples/flickr/popup.xsl	(revision 4307)
@@ -0,0 +1,46 @@
+<?xml version="1.0" encoding="UTF-8"?>
+
+<!--
+Description: presents the list of events in a GeoRSS
+Author:      adair
+Licence:     LGPL as specified in http://www.gnu.org/copyleft/lesser.html .
+
+$Id: popup.xsl 3907 2008-03-06 10:27:06Z steven $
+$Name:  $
+-->
+
+<xsl:stylesheet version="1.0" 
+  xmlns:xsl="http://www.w3.org/1999/XSL/Transform" 
+  xmlns:gml="http://www.opengis.net/gml"
+  xmlns:wfs="http://www.opengis.net/wfs"
+  xmlns:dc="http://purl.org/dc/elements/1.1/" 
+  xmlns:mb="http://mapbuilder.sourceforge.net/mapbuilder" >
+  
+  <!-- xsl:output method="html" omit-xml-declaration="yes" encoding="utf-8" indent="yes"/ -->
+  <xsl:output method="xml" indent="yes" omit-xml-declaration="yes"/>
+  <xsl:param name="fid"/>
+  
+  <xsl:template match="/">
+    <div class="PopupContainer">
+      <div class="PopupHeader">Info</div>
+      <div class="PopupContent">
+        <xsl:apply-templates/>
+      </div>
+    </div>
+  </xsl:template>
+  
+  <xsl:template match="wfs:FeatureCollection/gml:featureMember/*">
+    <xsl:if test="@fid=$fid">
+      <table cellspacing="0" border="0">
+    	<tr><td><b>title:</b> <xsl:value-of select="mb:title"/></td></tr>
+    	<tr><td><b>description:</b> <xsl:copy-of select="mb:description"/></td></tr>
+    	<tr><td><b>date:</b> <xsl:value-of select="dc:date"/></td></tr>
+      <tr><td><b>pos:</b> <xsl:value-of select="mb:geom/gml:Point/gml:coordinates"/></td></tr>
+      <tr><td align="center"><xsl:element name="img">
+        <xsl:attribute name="src"><xsl:value-of select="mb:url"/></xsl:attribute>
+      </xsl:element></td></tr>
+      </table>
+    </xsl:if>
+  </xsl:template>
+
+</xsl:stylesheet>
Index: lib/spatial/mapbuilder/examples/flickr/rss2ows.xsl
===================================================================
--- lib/spatial/mapbuilder/examples/flickr/rss2ows.xsl	(nonexistent)
+++ lib/spatial/mapbuilder/examples/flickr/rss2ows.xsl	(revision 4307)
@@ -0,0 +1,70 @@
+<?xml version="1.0" encoding="UTF-8"?>
+<xsl:stylesheet version="1.0" 
+xmlns:xsl="http://www.w3.org/1999/XSL/Transform" 
+xmlns:rdf="http://www.w3.org/1999/02/22-rdf-syntax-ns#" 
+xmlns:rss="http://purl.org/rss/1.0/" 
+xmlns:taxo="http://purl.org/rss/1.0/modules/taxonomy/" 
+xmlns:dc="http://purl.org/dc/elements/1.1/" 
+xmlns:syn="http://purl.org/rss/1.0/modules/syndication/" 
+xmlns:georss="http://www.georss.org/rss"  
+xmlns:xlink="http://www.w3.org/1999/xlink"
+xmlns:gml="http://www.opengis.net/gml/3.1.1" 
+xmlns:wmc="http://www.opengis.net/context" 
+xmlns:sld="http://www.opengis.net/sld" 
+xmlns:ogc="http://www.opengis.net/ogc"
+xmlns:media="http://search.yahoo.com/mrss"> 
+
+	<!-- xsl:output method="html" omit-xml-declaration="yes" encoding="utf-8" indent="yes"/ -->
+	<xsl:output method="xml" omit-xml-declaration="yes" encoding="utf-8" indent="yes"/>
+  
+	<xsl:template match="/">
+		<ResourceList xmlns="http://www.opengis.net/context" >
+			<xsl:apply-templates select="."/>
+		</ResourceList>
+	</xsl:template>
+	
+	<xsl:template match="photo">
+    <xsl:variable name="pid"><xsl:value-of select="@pid"/></xsl:variable>
+    <xsl:variable name="id"><xsl:value-of select="@id"/></xsl:variable>
+    <xsl:variable name="width"><xsl:value-of select="@width"/></xsl:variable>
+    <xsl:variable name="height"><xsl:value-of select="@height"/></xsl:variable>
+    <xsl:variable name="title"><xsl:value-of select="@title"/></xsl:variable>
+    <xsl:variable name="secret"><xsl:value-of select="@secret"/></xsl:variable>
+    <xsl:variable name="server"><xsl:value-of select="@server"/></xsl:variable>
+    <xsl:variable name="link">http://www.flickr.com/photos/15435549@N00/<xsl:value-of select="$id"/>/</xsl:variable>
+    <xsl:variable name="thn">http://static.flickr.com/<xsl:value-of select="$server"/>/<xsl:value-of select="$id"/>_<xsl:value-of select="$secret"/>_s.jpg</xsl:variable>
+   
+		<wmc:RssLayer  queryable="0" hidden="0" id="{$id}" width="{$width}" height="{$height}" pid="{$id}" >
+			<wmc:Server service="GeoRSS" version="1.0" title="{$title}">
+				<wmc:OnlineResource xlink:type="simple" xlink:href="{$link}"/>
+			</wmc:Server>
+			<wmc:Name><xsl:value-of select="$title"/></wmc:Name>
+			<wmc:Title><xsl:value-of select="$title"/></wmc:Title>
+			<wmc:StyleList>
+        <wmc:Style>
+          <wmc:Name>Highlite</wmc:Name>
+          <sld:PointSymbolizer>
+           <sld:Stroke> 
+              <sld:CssParameter name="stroke">#ffff00</sld:CssParameter> 
+              <sld:CssParameter name="stroke-width">1</sld:CssParameter> 
+            </sld:Stroke> 
+          </sld:PointSymbolizer>
+        </wmc:Style>
+        <wmc:Style>
+          <wmc:Name>Normal</wmc:Name>
+          <sld:PointSymbolizer>
+            <sld:Graphic>
+              <sld:ExternalGraphic>
+                <sld:OnlineResource xlink:type="simple" xlink:href="{$thn}" />
+              </sld:ExternalGraphic> 
+              <sld:Size>32</sld:Size>
+            </sld:Graphic> 
+          </sld:PointSymbolizer>
+        </wmc:Style>
+      </wmc:StyleList>
+			<wmc:Abstract><img src='{$thn}' /><br/><a href="{$link}" target="_blank" >Flickr Link</a></wmc:Abstract>
+			<wmc:Where></wmc:Where>
+		</wmc:RssLayer>
+	</xsl:template>
+	
+</xsl:stylesheet>
Index: lib/spatial/mapbuilder/examples/flickr/WfsListing.xsl
===================================================================
--- lib/spatial/mapbuilder/examples/flickr/WfsListing.xsl	(nonexistent)
+++ lib/spatial/mapbuilder/examples/flickr/WfsListing.xsl	(revision 4307)
@@ -0,0 +1,53 @@
+<?xml version="1.0" encoding="UTF-8"?>
+
+<!--
+Description: presents the list of events in a GeoRSS
+Author:      adair
+Licence:     LGPL as specified in http://www.gnu.org/copyleft/lesser.html .
+
+$Id: GeoRSSListing.xsl 3017 2007-07-26 23:01:32Z ahocevar $
+$Name:  $
+-->
+
+<xsl:stylesheet version="1.0" 
+  xmlns:xsl="http://www.w3.org/1999/XSL/Transform" 
+  xmlns:wfs="http://www.opengis.net/wfs"
+  xmlns:gml="http://www.opengis.net/gml"
+  xmlns:dc="http://purl.org/dc/elements/1.1/" 
+  xmlns:mb="http://mapbuilder.sourceforge.net/mapbuilder">
+
+  <xsl:output method="xml" omit-xml-declaration="yes" encoding="utf-8" indent="yes"/>
+
+  <!-- The coordinates of the DHTML Layer on the HTML page -->
+  <xsl:param name="modelId"/>
+  <xsl:param name="targetModelId"/>
+  <xsl:param name="widgetId"/>
+  <xsl:param name="hiddenItems"/>
+  
+  <!-- template rule matching source root element -->
+  <xsl:template match="/">
+    <table>
+      <tr><th colspan="2">Community Mapbuilder Community</th></tr>
+      <xsl:apply-templates select="//mb:geoRssFeature"/>
+    </table>
+  </xsl:template>
+
+  <xsl:template match="//mb:geoRssFeature">
+    <xsl:variable name="fid"><xsl:value-of select="@fid"/></xsl:variable>
+    <xsl:variable name="link"><xsl:value-of select="mb:photopage"/></xsl:variable>
+    <xsl:variable name="icon"><xsl:value-of select="mb:url"/></xsl:variable>
+    <tr>
+      <td>
+        <input type="checkbox" checked="checked" onclick="this.checked?config.objects.{$modelId}.setParam('showFeature','{$fid}'):config.objects.{$modelId}.setParam('hideFeature','{$fid}')" />
+      </td>
+      <td onmouseover="config.objects.{$modelId}.setParam('highlightFeature','{$fid}')" onmouseout="config.objects.{$modelId}.setParam('dehighlightFeature','{$fid}')">
+        <table><tr>
+        <td valign="top"><img src="{$icon}" /></td>
+        <td valign="top"><a href="{$link}" target="_blank"><xsl:value-of select="mb:title"/></a><br/>
+        <xsl:value-of select="mb:description"/></td>
+        </tr></table>
+      </td>
+    </tr>
+  </xsl:template>
+
+</xsl:stylesheet>
Index: lib/spatial/mapbuilder/examples/catalog/CatalogSearchForm.xsl
===================================================================
--- lib/spatial/mapbuilder/examples/catalog/CatalogSearchForm.xsl	(nonexistent)
+++ lib/spatial/mapbuilder/examples/catalog/CatalogSearchForm.xsl	(revision 4307)
@@ -0,0 +1,145 @@
+<?xml version="1.0" encoding="ISO-8859-1"?>
+
+<!--
+Description: parses an listing of OGC services from the Discovery Portal registry
+Author:      adair
+Licence:     LGPL as specified in http://www.gnu.org/copyleft/lesser.html .
+
+$Id: CatalogSearchForm.xsl 3285 2007-09-20 09:31:07Z rdewit $
+$Name:  $
+-->
+
+<xsl:stylesheet version="1.0" 
+    xmlns:xsl="http://www.w3.org/1999/XSL/Transform" 
+		xmlns:ogc="http://www.opengis.net/ogc"
+		xmlns:gml="http://www.opengis.net/gml"
+    xmlns:xlink="http://www.w3.org/1999/xlink">
+
+  <xsl:output method="xml" omit-xml-declaration="yes" encoding="utf-8" indent="yes"/>
+
+  <!-- The coordinates of the DHTML Layer on the HTML page -->
+  <xsl:param name="modelTitle"/>
+  <xsl:param name="modelId"/>
+  <xsl:param name="widgetId"/>
+  <xsl:param name="targetModelId"/>
+  <xsl:param name="targetModel"/>
+  <xsl:param name="lang">en</xsl:param>
+  
+  <xsl:param name="webServiceUrl">http://devgeo.cciw.ca/cgi-bin/mapserv/owscat</xsl:param>
+  <xsl:param name="formName">owsCatSearch</xsl:param>
+  <!-- NOTE: it's really bad form to put a hard-coded URL here, but it's the only way to use the document() function in IE -->
+  <!--xsl:param name="searchConfigDoc" select="document('http://demo.communitymapbuilder.org/mapbuilder-lib-1.0-release/demo/contextEditor/searchConfig.xml')"/-->  
+  <xsl:param name="searchConfigDoc" select="document('http://geodiscover.cgdi.ca/mapbuilder/demo/contextEditor/searchConfig.xml')"/>  
+  <xsl:param name="selectSize" select="1"/>
+  
+  <!-- Text params for this widget -->
+  <xsl:param name="north">North</xsl:param>
+  <xsl:param name="south">South</xsl:param>
+  <xsl:param name="east">East</xsl:param>
+  <xsl:param name="west">West</xsl:param>
+  
+  <!-- template rule matching source root element -->
+  <xsl:template match="/">
+    <div>
+    <h2>Search for layers</h2>
+    <form name="{$formName}" id="{$formName}" method="get" onsubmit="config.objects.{$widgetId}.doSelect();return false;">
+      <!--
+      <input type="hidden" name="version" value="1.0.0"/>
+      <input type="hidden" name="service" value="WFS"/>
+      <input type="hidden" name="request" value="GetFeature"/>
+      <input type="hidden" name="typename" value="service_resources"/>
+      <input type="hidden" name="outputFormat" value="GML3"/>
+      -->
+      <table>
+        <tr>
+          <td>
+            <h3>Keywords</h3>
+          </td>
+          <td>
+            <h3>Service Type</h3>
+          </td>
+          <td/>
+        </tr>
+        <tr>
+          <td>
+            <input type="text" name="keywords" value=""/>
+          </td>
+          <td>
+            <select name="serviceType" id="serviceType">
+              <option></option>
+              <option value="WMS">WMS</option>
+              <option value="WFS">WFS</option>
+            </select>
+            <input type="submit" value="search"/>
+          </td>
+          <td>
+            <div id="loading"></div>
+          </td>
+        </tr>
+      </table>
+      <!--
+      <div id="locations">
+        <xsl:call-template name="aoiBox"/>
+      </div>
+      -->
+
+    </form>
+
+    </div>
+  </xsl:template>
+
+  <xsl:template name="locations">
+    <xsl:param name="locationsDoc"/>
+    <div>
+      <select name="locations" onchange="config.objects.{$widgetId}.setLocation(this.options[this.selectedIndex].value);" size="{$selectSize}">
+        <xsl:apply-templates select="$locationsDoc/searchConfig[@entryType='productCollection']/locations/location"/>
+      </select>
+    </div>
+  </xsl:template>
+  
+  <xsl:template match="location">
+    <xsl:param name="indent"/>
+    <xsl:variable name="bbox" select="translate(wens,' ',',')"/>
+    <option value="{$bbox}"><xsl:value-of select="$indent"/><xsl:value-of select="title[@lang=$lang]"/></option>
+    <xsl:apply-templates select="location">
+      <xsl:with-param name="indent"><xsl:value-of select="$indent"/>&#160;&#160;</xsl:with-param>
+    </xsl:apply-templates>
+  </xsl:template>
+  
+  <!--
+  <xsl:template name="aoiBox">
+      <h3>Location</h3>
+      <table>
+        <tr>
+          <td><xsl:value-of select="$west"/></td>
+          <td><xsl:value-of select="$south"/></td>
+          <td><xsl:value-of select="$east"/></td>
+          <td><xsl:value-of select="$north"/></td>
+        </tr>
+        <tr>
+          <td>
+            <input name="westCoord" type="text" size="10" class="searchInput" onblur="config.objects.{$widgetId}.setAoi(config.objects.{$widgetId});"/>
+          </td>
+          <td>
+            <input name="southCoord" type="text" size="10" class="searchInput" onblur="config.objects.{$widgetId}.setAoi(config.objects.{$widgetId});"/>
+          </td>
+          <td>
+            <input name="eastCoord" type="text" size="10"  class="searchInput" onblur="config.objects.{$widgetId}.setAoi(config.objects.{$widgetId});"/>
+          </td>
+          <td>
+            <input name="northCoord" type="text" size="10" class="searchInput" onblur="config.objects.{$widgetId}.setAoi(config.objects.{$widgetId});"/>
+          </td>
+        </tr>
+      </table>
+  </xsl:template>
+  -->
+  
+  <xsl:template name="ntsInput">
+    <p>or enter NTS mapsheet index
+      <input name="ntsIndex" type="text" size="6" class="searchInput"/>
+    </p>
+  </xsl:template>
+ 
+  <xsl:template match="text()|@*"/>
+
+</xsl:stylesheet>
Index: lib/spatial/mapbuilder/examples/catalog/LayerMetadata.xsl
===================================================================
--- lib/spatial/mapbuilder/examples/catalog/LayerMetadata.xsl	(nonexistent)
+++ lib/spatial/mapbuilder/examples/catalog/LayerMetadata.xsl	(revision 4307)
@@ -0,0 +1,54 @@
+<?xml version="1.0" encoding="UTF-8"?>
+<xsl:stylesheet version="1.0" xmlns:wmc="http://www.opengis.net/context" xmlns:xsl="http://www.w3.org/1999/XSL/Transform" xmlns:xlink="http://www.w3.org/1999/xlink" >
+<!--
+Description: Output the metadata of a layer 
+Author:      Roald de Wit rdewit@lisasoft.com
+Licence:     LGPL as per: http://www.gnu.org/copyleft/lesser.html
+LayerMetadata.xsl,v 1.5 2004/06/25 17:59:38 rdewit Exp
+
+-->
+  <xsl:output method="xml" encoding="utf-8" omit-xml-declaration="yes"/>
+  
+  <!-- The common params set for all widgets -->
+  <xsl:param name="lang">en</xsl:param>
+  <xsl:param name="widgetNode"/>
+  
+  <!-- Text params for this widget -->
+  <xsl:param name="abstract"/>
+  <xsl:param name="moreInfo"/>
+  
+  <!-- Node with layer information -->
+  <xsl:param name="layerNode"/>
+  
+  <xsl:template match="/">
+  <div>
+    <xsl:apply-templates select="$layerNode"/>
+  </div>
+  </xsl:template>
+
+  <xsl:template match="wmc:Layer|wmc:FeatureType">
+    <table class="metadata">
+    <xsl:if test="wmc:Server/@service">
+    <tr><td>Service:</td><td><xsl:value-of select="wmc:Server/@service"/></td></tr>
+    </xsl:if>
+    <xsl:if test="wmc:Name/text()">
+    <tr><td>Name:</td><td><xsl:value-of select="wmc:Name"/></td></tr>
+    </xsl:if>
+    <xsl:if test="wmc:Title/text()">
+    <tr><td>Title:</td><td><xsl:value-of select="wmc:Title"/></td></tr>
+    </xsl:if>
+    <xsl:if test="wmc:Abstract/text()">
+    <tr><td>Abstract:</td><td><xsl:value-of select="wmc:Abstract"/></td></tr>
+    </xsl:if>
+    <xsl:if test=".//wmc:OnlineResource/@xlink:href">
+    <tr><td>Resource:</td><td><xsl:value-of select=".//wmc:OnlineResource/@xlink:href"/></td></tr>
+    </xsl:if>
+    <xsl:if test="@id">
+    <tr><td>Id:</td><td><xsl:value-of select="@id"/></td></tr>
+    </xsl:if>
+    </table>
+  </xsl:template>
+  <xsl:template match="text()|@*"/>
+  
+</xsl:stylesheet>
+
Index: lib/spatial/mapbuilder/examples/catalog/LayerControl.js
===================================================================
--- lib/spatial/mapbuilder/examples/catalog/LayerControl.js	(nonexistent)
+++ lib/spatial/mapbuilder/examples/catalog/LayerControl.js	(revision 4307)
@@ -0,0 +1,158 @@
+/*
+License: GPL as per: http://www.gnu.org/copyleft/gpl.html
+$Id: LayerControl.js 3607 2007-11-16 05:06:51Z rdewit $
+*/
+
+// Ensure this object's dependancies are loaded.
+mapbuilder.loadScript(baseDir+"/widget/WidgetBaseXSL.js");
+
+/**
+ * Widget to allow control of layer odering, visibility, deletion
+ * @constructor
+ * @base WidgetBaseXSL
+ * @author adair
+ * @param widgetNode  The widget's XML object node from the configuration document.
+ * @param model       The model object that this widget belongs to.
+ */
+function LayerControl(widgetNode, model) {
+  WidgetBaseXSL.apply(this,new Array(widgetNode, model));
+
+  /**
+   * Override of widget prepaint to set some stylesheet parameters including 
+   * featureName (for OWS Context) and hidden attribute.
+   * @param objRef Pointer to this object.
+   */
+  this.prePaint = function(objRef) {
+    if (objRef.model.featureName) {
+    
+      objRef.stylesheet.setParameter("featureName", objRef.model.featureName );
+      objRef.stylesheet.setParameter("hidden", objRef.model.getHidden(objRef.model.featureName).toString() );
+    }
+    objRef.stylesheet.setParameter("layerMetadata", objRef.model.getParam("layerMetadata"));
+  }
+
+  /**
+   * Hide loading spinner when layer stops loading
+   * @param ojbRef Pointer the calling object
+   * @param layerId Id of the layer
+   */
+  this.loadLayerStart = function(objRef, layerId) {
+    //console.info('LayerLoading Show: ' + layerId);
+    layerNode = objRef.model.getLayer(layerId);
+    if (layerNode) {
+      layerNode.setAttribute("isLoading", true);
+      objRef.refresh(objRef, layerId);
+    }
+  }
+  this.model.addListener("loadLayerStart",this.loadLayerStart, this);
+  
+  /**
+   * Show loading spinner when layer starts loading
+   * @param ojbRef Pointer the calling object
+   * @param layerId Id of the layer
+   */
+  this.loadLayerEnd = function(objRef, layerId) {
+    //console.info('LayerLoading Hide: ' + layerId);
+    layerNode = objRef.model.getLayer(layerId);
+    if (layerNode) {
+      layerNode.removeAttribute("isLoading");
+      objRef.refresh(objRef, layerId);
+    }
+  }
+  this.model.addListener("loadLayerEnd",this.loadLayerEnd, this);
+
+
+  /**
+   * Displays a layer in a preview pane when mouse is over the table row
+   * @param layerId  the name of the layer to highlight
+   */
+  this.highlightLayer = function(layerId) {
+    if (this.model && this.model.map) {
+      var layer = this.model.map.mbMapPane.oLlayers[layerId].div;
+      var previewImage = document.getElementById("previewImage");
+      try {
+        if (previewImage && layer) previewImage.src = layer.firstChild.firstChild.src;
+      } catch(e) {}
+    }
+  }
+
+  /**
+   * Listener method to paint this widget
+   * @param layerName  the name of the layer to highlight
+   */
+  this.refresh = function(objRef, layerName) {
+    objRef.paint(objRef, objRef.id);
+  }
+  this.model.addListener("deleteLayer",this.refresh, this);
+  this.model.addListener("moveLayerUp",this.refresh, this);
+  this.model.addListener("moveLayerDown",this.refresh, this);
+  if (this.autoRefresh) this.model.addListener("addLayer",this.refresh, this);
+  
+  this.foldUnfoldGroup = function(groupName,id) {
+    // context config stuff to maintain group folding over refresh
+    var xpathExpression = "//wmc:General/wmc:Extension/wmc:GroupList/wmc:Group[@name='" + groupName + "']";
+    //var thisGroupsLayerNodes = model.doc.selectNodes(xpathExpression);
+    var thisGroupsNode = model.doc.selectSingleNode(xpathExpression);
+    var thisGroupsFoldedState = thisGroupsNode.getAttribute('folded');
+    var e =document.getElementById(id);
+    if(thisGroupsFoldedState == "1") {
+		thisGroupsNode.setAttribute("folded", "0");
+		e.value="-";
+		
+	} else {
+		thisGroupsNode.setAttribute("folded", "1");
+		e.value="+";
+	}
+	
+  }
+
+  /**
+   * Change image source from imageA to imageB
+   * @param id  id of image tag where we want to change the source
+   * @param imageA   url of imageA
+   * @param imageB   url of imageB
+   */
+  this.ChangeImage= function (id, imageA, imageB) {
+     var indexA=document.getElementById(id).src.indexOf(imageA);
+     var indexB=document.getElementById(id).src.indexOf(imageB);
+     if (document.getElementById(id) != null) {
+        if (indexA != -1) { /* HACK for IE. */
+            document.getElementById(id).src=document.getElementById(id).src.substring(0,indexA)+imageB;
+        } else {
+           document.getElementById(id).src=document.getElementById(id).src.substring(0,indexB)+imageA;
+        }
+     }
+     return;
+}
+
+/**
+   * Display or fold  the layer's legend
+   * @param id  id of legend div
+   */
+	this.switchVisibilityById = function (id) {
+	e =document.getElementById(id);
+	
+		if (e.style.display=="none") {
+			e.style.display = "block";
+		} else {
+			e.style.display = "none";
+		}
+		
+	
+     }
+
+  /**
+   * Copy a layer from this model's context to the targetModel's context.
+   * @param layerId The id of the layer selected.
+   */
+  this.copyToTargetModel = function(layerId) {
+
+    // Fetch layerNode from model and clone it 
+    var layerNode=this.model.getLayer(layerId).cloneNode(true);
+
+    //Add layerNode to the target model
+    this.targetModel.setParam("addLayer",layerNode);
+  }
+
+}
+
